Description

On my recent git install of foreman, when I go to http://myforeman:3000/statistics

"No Inventory data has been found - add some hosts and facts and try again"

However I have lots of hosts with inventory data.

Associated revisions

Revision 52a909a3 - 01/07/2010 02:06 AM - Ohad Levy

fixes #138 - Statistics page doesn't show any info if memory facts are unavailable

History

#1 - 12/19/2009 12:30 AM - Ohad Levy

I would your help to debug this a bit, could you try opening a console - e.g.

./script/console production

 and copy paste every line from the index method of the statistics controller (app/controllers/statistics_controller)?

one one of them will give a useful error message.

thanks

#2 - 12/19/2009 12:30 AM - Ohad Levy

- Category set to Inventory

- Status changed from New to Need more information

- Assignee set to Nigel Kersten

#3 - 12/22/2009 05:01 PM - John Lyman

I am also having the same issue.  Here is the output from my console session:

./script/console production

Loading production environment (Rails 2.3.2)

class StatisticsController < ApplicationController

def index

begin

?>       @os_count = Host.count_distribution :operatingsystem

@arch_count = Host.count_distribution :architecture

@env_count = Host.count_distribution :environment

@klass_count = Host.count_habtm "puppetclass"

@cpu_count = FactValue.count_each "processorcount"
@model_count = FactValue.count_each "manufacturer"

@mem_size = FactValue.mem_average "memorysize"

@mem_free = FactValue.mem_average "memoryfree"

@swap_size = FactValue.mem_average "swapsize"

@swap_free = FactValue.mem_average "swapfree"

rescue

render :text => "No Inventory data has been found - add some hosts and facts and try again", :layout => true

end

end

end

=> nil

Also, under the "Settings" tab, "Puppet Classes" and "Puppet Groups" have no entries.  "Domains", "Operating Systems", "Architectures", etc. are

populated.  Not sure if this is related to the issue or not.

#4 - 12/22/2009 05:04 PM - John Lyman

Sorry, I should have previewed that before I submitted.  Here is the console output in a better format:

./script/console production

Loading production environment (Rails 2.3.2)

>> class StatisticsController < ApplicationController

>>   def index

>>     begin

?>       @os_count = Host.count_distribution :operatingsystem

>>       @arch_count = Host.count_distribution :architecture

>>       @env_count = Host.count_distribution :environment

>>       @klass_count = Host.count_habtm "puppetclass" 

>>       @cpu_count = FactValue.count_each "processorcount" 

>>       @model_count = FactValue.count_each "manufacturer" 

>>       @mem_size = FactValue.mem_average "memorysize" 

>>       @mem_free = FactValue.mem_average "memoryfree" 

>>       @swap_size = FactValue.mem_average "swapsize" 

>>       @swap_free = FactValue.mem_average "swapfree" 

>>     rescue

>>       render :text => "No Inventory data has been found - add some hosts and facts and try again", :layout 

=> true

>>     end

>>   end

>> end

=> nil

#5 - 12/23/2009 04:23 AM - John Warburton

I get this error when I have a new host entry sent by the puppet report (foreman.rb) but before the facts are delivered to the central foreman server via

push_facts.rb.

So, a single new host with no facts blows the statistics page away until the facts appear

Since push_facts runs every 5 minutes and the number of new hosts added is low, it is a rare error message for me, so I didn't worry about reporting

it

http://theforeman.org/wiki/foreman/Puppet_Facts

#6 - 12/23/2009 01:46 PM - John Lyman

I have a cron that runs 

rake puppet:import:hosts_and_facts RAILS_ENV=production

every 5 minutes without errors, and I still don't see the statistics page.

#7 - 12/25/2009 08:39 AM - Ohad Levy

John Lyman wrote:

Sorry, I should have previewed that before I submitted.  Here is the console output in a better format:

[...]

 You should execute everything between the begin and rescue, if you include those (begin rescue end), you will not see the actual error message...
once I'm back from my vacation, I'll add some error handling into the logs, so it would be obvious where the error is..

#8 - 12/29/2009 03:20 PM - John Lyman

Here it is again, with just the statements between begin and rescue.  It looks like some facts have null values, but I'm not sure how to debug further...

Loading production environment (Rails 3.3.2)

>> @os_count = Host.count_distribution :operatingsystem

=> {"Solaris 5.10"=>8}

>> @arch_count = Host.count_distribution :architecture

=> {"i386"=>4, "sparc"=>4}

>> @env_count = Host.count_distribution :environment

=> {"production"=>8}

>> @klass_count = Host.count_habtm "puppetclass" 

=> {nil=>8}

>> @cpu_count = FactValue.count_each "processorcount" 

=> {}

>> @model_count = FactValue.count_each "manufacturer" 

=> {"Sun microsystems"=>4}

>> @mem_size = FactValue.mem_average "memorysize" 

ZeroDivisionError: divided by 0

        from /export/home/jlyman/foreman/foreman/app/models/fact_value.rb:14:in `/'

        from /export/home/jlyman/foreman/foreman/app/models/fact_value.rb:14:in `mem_average'

        from (irb):7

>> @mem_free = FactValue.mem_average "memoryfree" 

ZeroDivisionError: divided by 0

        from /export/home/jlyman/foreman/foreman/app/models/fact_value.rb:14:in `/'

        from /export/home/jlyman/foreman/foreman/app/models/fact_value.rb:14:in `mem_average'

        from (irb):8

>> @swap_size = FactValue.mem_average "swapsize" 

ZeroDivisionError: divided by 0

        from /export/home/jlyman/foreman/foreman/app/models/fact_value.rb:14:in `/'

        from /export/home/jlyman/foreman/foreman/app/models/fact_value.rb:14:in `mem_average'

        from (irb):9

>> @swap_free = FactValue.mem_average "swapfree" 

ZeroDivisionError: divided by 0

        from /export/home/jlyman/foreman/foreman/app/models/fact_value.rb:14:in `/'

        from /export/home/jlyman/foreman/foreman/app/models/fact_value.rb:14:in `mem_average'

        from (irb):10

#9 - 12/29/2009 03:37 PM - John Lyman

Apparently, there are no memory facts for puppet on Solaris:

Feature #1423 - Memory facts for Solaris

#10 - 12/30/2009 07:21 AM - Ohad Levy

John Lyman wrote:

Here it is again, with just the statements between begin and rescue.  It looks like some facts have null values, but I'm not sure how to debug

further...

[...]

 OK - this is a stupid yet simple bug to fix, to get around the problem for now, just comment out the two methods (memory and swap queries) - I'll get

to it when I'm back.

(you would also need to comment it out in the view (I think app/views/statistics/index.html.erb) - where it says something like Avg memory usage

#11 - 12/30/2009 02:14 PM - John Lyman

It's working now, thanks.

#12 - 01/04/2010 04:02 PM - Nigel Kersten

I imagine I have the same problem due to Mac clients not reporting the memory facts too? Back from holidays today, will investigate more.

#13 - 01/06/2010 05:22 AM - Ohad Levy

- Status changed from Need more information to Assigned

- Target version set to 0.1-4
#14 - 01/07/2010 02:06 AM - Ohad Levy

- Subject changed from Statistics page doesn't show any info. to Statistics page doesn't show any info if memory facts are unavailable

#15 - 01/07/2010 02:08 AM - Ohad Levy

- Status changed from Assigned to Ready For Testing

- % Done changed from 0 to 100

Applied in changeset 52a909a39b9766e2a579f1819fcd090d1a123346.

#16 - 01/12/2010 01:10 PM - Ohad Levy

- Status changed from Ready For Testing to Closed
